/*
 * C
 *
 * Copyright 2013 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
#include <stdio.h>
#include "leds.h"

#define INCREMENTOR     1000U
#define FAST            1000U
#define SLOW            (FAST*10U)

unsigned int counter = 0;

void count(void)
{
    int i=0;
    for(i=0 ; i<INCREMENTOR ; i++)
    {
        counter++;
               
        if(counter ==0)
        {
            LEDs_toggleLED(2);
            LEDs_toggleLED(3);
            return; // terminates the loop after a overflow of counter
        }
    }
}

void fast_toogle(void)
{
    if(counter % (INCREMENTOR*FAST) == 0)
    {
        LEDs_toggleLED(0);
    }
}


void slow_toogle(void)
{
    if(counter % (INCREMENTOR*SLOW) == 0)
    {
        LEDs_toggleLED(1);
    }
}    


void counter_to_uart(void)
{
    printf("Counter = %d\n", counter);
}

void fibonacci(void)
{
    static unsigned int fn = 1;
    static unsigned int fn1 = 1;
    static unsigned int month = 1;    
    unsigned int fn2 = 0;
    
    // Current month
    if(month <= 2)
    {
        fn2 = 1;
    }
    else
    {
        fn2 = fn1 + fn;
    }
    
    // Display if no overflow
    if(fn2 >= fn1 && fn2 >= fn)
    {
        printf("%dth month : %u couples\n", month, fn2);
        // Next month
        fn = fn1;
        fn1 = fn2;
        month++;
    }
}
    
    
