/**
 * Copyright 2013 IS2T. All rights reserved
 * For demonstration purpose only
 * IS2T PROPRIETARY / Use is subject to license terms.
 */
package com.is2t.examples;

public class Scheduler {
	// Native functions --> implementation is done in C code
	private native static void Task1();
	private native static void Task2();
	private native static void Task3();
	private native static void Task4();
	private native static void Task5();
	
	
	// Java functions	
	private static int Un = 15;
	private static boolean TrivialCyleReached = false;
	private static void SyracuseSequence() {
		
		if(TrivialCyleReached == false) {  // don't print if trivial cycle has been reached
			System.out.println("Syracuse : " + Un);
		}
			
		if(Un % 2 == 0) {
			// Even
			Un = Un /2;
			if(Un == 1) {
				TrivialCyleReached = true;
			}
		}
		else {
			// Odd
			Un = 3*Un + 1;
		}		
	}
	
	// Main function schedules both C and Java tasks
	public static void main(String[] args) {
		System.out.println("Java scheduling starts...");
		
		while(true) {
			Task1();
			Task2();
			Task3();
			Task4();
			Task5();
			SyracuseSequence();
		}
	}
}
